// Copyright (c) 2008, NTT DATA Corporation.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

using System;
using System.Configuration;
using TERASOLUNA.Fw.Common.Logging;

namespace TERASOLUNA.Fw.Web.Configuration.Sql
{
    /// <summary>
    /// SQL 文設定ファイルから SqlConfiguration 設定情報を取得します。
    /// </summary>
    public abstract class SqlConfiguration
    {
        /// <summary>
        /// <see cref="ILog"/> 実装クラスのインスタンスです。
        /// </summary>
        /// <remarks>
        /// ログ出力に利用します。
        /// </remarks>
        private static ILog _log = LogFactory.GetLogger(typeof(SqlConfiguration));

        /// <summary>
        /// SQL 文を取得します。
        /// </summary>
        /// <param name="name">取得する SQL 文の識別子。</param>
        /// <returns>識別子に対応する SQL 文。</returns>
        /// <remarks>
        /// SQL 文設定ファイルから、name の値に対応する SQL 文を取得します。
        /// </remarks>
        /// <exception cref="ArgumentNullException">
        /// <paramref name="name"/> が null 参照です。
        /// </exception>
        /// <exception cref="ArgumentException">
        /// <paramref name="name"/> が空文字です。
        /// </exception>
        /// <exception cref="ConfigurationErrorsException">
        /// 次のような場合に例外をスローします。
        /// <list type="bullet">
        /// <item>
        /// 構成ファイルを読み込むことができません。
        /// </item>
        /// <item>
        /// <paramref name="name"/> の値に対応する SQL 文が存在しない場合。
        /// </item>
        /// </list>
        /// </exception>
        public static string GetSql(string name)
        {
            if (name == null)
            {
                ArgumentNullException exception = new ArgumentNullException("name");
                if (_log.IsErrorEnabled)
                {
                    _log.Error(string.Format(
                        Properties.Resources.E_NULL_ARGUMENT, "name"), exception);
                }
                throw exception;
            }
            if (name.Length == 0)
            {
                string message = string.Format(Properties.Resources.E_EMPTY_STRING, "name");
                ArgumentException exception = new ArgumentException(message);
                if (_log.IsErrorEnabled)
                {
                    _log.Error(message, exception);
                }
                throw exception;
            }

            SqlElement sqlElement = TerasolunaWebConfiguration.SqlConfigSection.Sqls[name];

            if (sqlElement == null)
            {
                string message = string.Format(Properties.Resources.E_SQL_STATEMENT_NOT_FOUND, name);
                ConfigurationErrorsException exception = new ConfigurationErrorsException(message);
                if (_log.IsErrorEnabled)
                {
                    _log.Error(message, exception);
                }
                throw exception;
            }

            if (_log.IsTraceEnabled)
            {
                _log.Trace(string.Format(Properties.Resources.T_SQL_CONFIGURATION_LOAD_SQL, name, sqlElement.Statement));
            }

            return sqlElement.Statement;
        }
    }
}
